# Custom Ore Generator

**Welcome to CustomOreGen! CustomOreGen gives you the ability to customize your SkyBlock server's cobblestone generator!**

![](/media/CustomOreGenerator-Cobble.png) ![](/media/CustomOreGenerator-DiamondOre.png)
# Features
* Different generator presets based on permission nodes and/or island levels
* Compatibile with BentoBox, ASkyBlock, AcidIsland, uSkyBlock, SuperiorSkyblock2, IslandWorld, and PlotSquared
* Configurable spawning rate of any block
* Item Sub IDs are supported
* Open Source: [Source](https://github.com/mastercake10/CustomOreGen) 

# Installation
#### Choose a SkyBlock plugin

In order to run CustomOreGen, one of the following plugins need to be installed and running using Spigot 1.7-1.14.

* BentoBox (by Tastybento) 
* ASkyBlock (by Tastybento)
* AcidIsland (by Tastybento)
* uSkyBlock (by R4zorax)
* Island World (by Gnacik)
* SuperiorSkyblock2 (by Oma_R)
* PlotSquared (by IntellectualSites)

**BentoBox Users** The BentoBox Level Addon is required in order to run CustomOreGen

#### Downloading Custom Ore Generator

1. Download the CustomOreGen plugin [here](https://www.spigotmc.org/resources/customoregen.9532/).
2. Place the CustomOreGen.jar file into your server's plugin folder.
3. Restart your server (Using the /Reload command is not recommended!)

# Creating a Generator
#### Important notices:

* When creating generators, each category should be named "generator1", "generator2", and so on. 

* 1.13/1.14 users: Make sure to use Bukkit material (block) names when putting blocks in a generator category. A list of the Bukkit material names can be found [here](https://hub.spigotmc.org/javadocs/bukkit/org/bukkit/Material.html).
 
* A generator category must include a 100.0% spawnrate. For example, in the screenshot below, STONE has a 50.0% of being produced, SANDSTONE has a 40.0% chance of being produced, and IRON_ORE has a 10.0% chance of being produced, equaling the 100.0% required (50.0% + 40.0% + 10.0% = 100.0%).

![](/media/CustomOreGenConfig.png)

#### Unlocking Generators using Island Level and Permissions
* When unlocking a generator using permission nodes, the same generator can only be used by all island members if the island owner has the permission. Though, if the island owner goes offline, the default generator in the configuration file will be used.

* When unlocking a generator using island level, the generator will only apply to all island members unless the island owner goes offline. The default generator in the configuration file will be used when the island owner is not online.

![](/media/CustomOreGenUnlock.png)

**Looking for offline owner support? Check out [Advanced Ore Generator](https://www.spigotmc.org/resources/advancedoregen.40527/)!**
# Commands
| Command | Permission | Description |
| -------- | -------- | -------- |
| /CustomOreGen     | CustomOreGen.admin     | Reloads the configuration file     |

# FAQ

Q: Does this plugin need a skyblock plugin?
A: Yes it does. The plugin is used to obtain the permssion (or level) of the owner, in order to choose a generator. In a plain vanilla world, there is no way to fetch directly the player permissions mining on the generator. What if two players are mining at one generator, but both have access to different generators?


